import 'dart:async';
import 'package:bolter_flutter/bolter_flutter.dart';
import 'package:flutter/material.dart';

part 'presenter/presenter.dart';

part 'presenter/presenter_provider.dart';

part 'sync_builder.dart';

class BolterProvider extends StatelessWidget {
  final Widget child;
  final BolterInterface bolter;

  const BolterProvider({
    required this.bolter,
    Key? key,
    required this.child,
  }) : super(key: key);

  @override
  Widget build(BuildContext context) => child;
}

@Deprecated('use BolterProvider')
class BolterProviderOld extends StatelessWidget {
  final DependenciesContainer _container;
  final Widget child;

  const BolterProviderOld({
    required DependenciesContainer container,
    Key? key,
    required this.child,
  })  : _container = container,
        super(key: key);

  static BolterProviderOld of(BuildContext context) =>
      context.findAncestorWidgetOfExactType<BolterProviderOld>()!;

  static final _bolter = Bolter();

  T dependency<T>({bool existingInstance = false}) =>
      _container.dependency<T>(existingInstance: existingInstance);

  DependenciesContainer get dependenciesContainer => _container;

  @override
  Widget build(BuildContext context) => child;
}

@Deprecated('use BolterProvider')
extension BolterProviderExtension on BuildContext {
  BolterProviderOld bolterProvider() => BolterProviderOld.of(this);
}
